#include <stdio.h>  /* for perror() */
#include <stdlib.h> /* for exit() */
#include <string.h>     /* for memset() */
#include <pthread.h>        /* for POSIX threads */

pthread_mutex_t mtxcrypt     = PTHREAD_MUTEX_INITIALIZER;			//btkcrypt  mutex

//delspace
void delspace (char *Str1)
{
int Pntr = 0;
int Dest = 0;
while (Str1 [Pntr])
{
if (Str1 [Pntr] != ' ')
	Str1 [Dest++] = Str1 [Pntr];
Pntr++;
}
Str1 [Dest++] = 0;
}

//================== btkcrypt  CRYPT  =====================

void btkcrypt (char* message, int msglen, char *keyiv )
{
pthread_mutex_lock( &mtxcrypt );

unsigned char crp[1024];
int	ib;
unsigned char 	rand1,rand2,rand3;
char		*src;
unsigned char 	crkeys[8];
unsigned char 	*dst = crkeys;
unsigned char	*end = crkeys + sizeof(crkeys);
unsigned int 	tmpu;
						
src = keyiv;	//Convert hexchar array to  bytes
dst = crkeys;
end = crkeys + sizeof(crkeys);
while (dst < end && sscanf(src, "%2x", &tmpu) == 1)
	{
	*dst++ = tmpu;
	src += 2;
	}

memcpy(crp,message,msglen);

srand ( time(NULL) );
rand1 = rand() % 256;
rand2 = rand() % 256;
rand3 = rand2 & 0x7;

crp[msglen]=rand1;		// add rand1 to the end of crp
for (ib=0;ib<msglen;ib++) crp[ib]=crp[ib]^rand1;  //xor crp except rand1
for (ib=0;ib<msglen+1;ib++) 			 //rotate all using rand3
	crp[ib]=( ( crp[ib] >> rand3 ) | ( crp[ib] << (8-rand3) ) );
for (ib=0;ib<msglen+1;ib++) crp[ib]=crp[ib]^rand2;  //xor with rand2
crp[msglen+1]=rand2;
for (ib=0;ib<msglen+2;ib++)
	crp[ib]=crp[ib] ^ crkeys[ib % 8];
memcpy(message, crp,msglen+2);
pthread_mutex_unlock( &mtxcrypt );
}


//btk decrypt function
void btkdecrypt (char* message, int msglen, char *keyiv )
{
pthread_mutex_lock( &mtxcrypt );
unsigned char crp[1024];
int	ib;
unsigned char 	rand1,rand2,rand3;
char		*src;
unsigned char 	crkeys[8];
unsigned char 	*dst = crkeys;
unsigned char	*end = crkeys + sizeof(crkeys);
unsigned int 	tmpu;
						
src = keyiv;	//Convert hexchar array to bytes
dst = crkeys;
end = crkeys + sizeof(crkeys);
while (dst < end && sscanf(src, "%2x", &tmpu) == 1)
	{
	*dst++ = tmpu;
	src += 2;
	}

memcpy(crp,message,msglen);
for (ib=0;ib<msglen;ib++)			//xor with keys
	crp[ib]=crp[ib] ^ crkeys[ib % 8];

rand2=crp[msglen-1];			// last char is rand
rand3=rand2 & 0x7;
for (ib=0;ib<msglen;ib++)		//xor with rand2
	crp[ib]=crp[ib]^rand2;
for (ib=0;ib<msglen;ib++) 		//rotate all using rand3
	crp[ib]=( ( crp[ib] << rand3 ) | ( crp[ib] >> (8-rand3) ) );
rand1=crp[msglen-2];
for (ib=0;ib<msglen-1;ib++)		//xor with rand2
	crp[ib]=crp[ib]^rand1;
crp[msglen-1]=0;
memcpy(message,crp,msglen-1);
pthread_mutex_unlock( &mtxcrypt );
}


int BtxtEncry(char *input, char *output)
{
unsigned char 	arr[300];
int 		i,sum,len,rand1;
unsigned char 	table[8]={ 18,246,223,86,185,55,7,145 }; 
char		tmphx[3];

srand ( time(NULL) );
rand1 = rand() % 256;

len=strlen(input);
memset(arr,0,sizeof(arr));
memset(output,0,len*2+10);
memcpy(arr,input,len);
printf("Plain Text: %s\n",arr);
//Find Sum
sum=0;
for(i=0; i < len; i++)  sum += arr[i];
 
sum = sum & 0xff;
//printf("Rand1: %02x,  Sum: %02x\n",rand1,sum);
for (int i=0;i<len;i++)
		{
		arr[i]=arr[i]^(table[i%8]-rand1*(i+1))^sum;
		sprintf(tmphx,"%02x",arr[i]);
		strcat(output,tmphx);
		}
sprintf(tmphx,"%02x",sum^rand1);
strcat(output,tmphx);
sprintf(tmphx,"%02x",rand1);
strcat(output,tmphx);
return 1;
}

int BtxtDecry(char *input, char *output)
{
unsigned char 	arr[300];
int 		i,sum,len,rand1,tmp,sumc;
unsigned char 	table[8]={ 18,246,223,86,185,55,7,145 }; 

rand1 = rand() % 256;
len=strlen(input);
memset(arr,0,sizeof(arr));
memset(output,0,len);
printf("Crypt Text: %s\n",input);

//Find Sum
sscanf(input+len-2,"%02x",&rand1);
sscanf(input+len-4,"%02x",&sum);
sum = sum ^ rand1;
sumc=0;

for(i=0; i < len/2-2; i++) 
	{
	sscanf(input+i*2,"%02x",&tmp);
	arr[i]=tmp^(table[i%8]-rand1*(i+1))^sum;
	sumc+=arr[i];
	}
sumc = sumc & 0xff;
//printf("Rand1: %02x,  Sum: %02x,  SumC:%02x\n",rand1,sum,sumc);
if (sum!=sumc) return 0;
memcpy(output,arr,len/2);
return 1;
}

int DCWencode(unsigned char *input, int len)
{
int		say;
unsigned char 	arr[100];
unsigned char 	table[8]={ 181,46,23,186,65,250,7,199 }; 

//reverse
memcpy(arr,input,len);
for (say=0;say<len;say++)
	arr[len-1-say]=input[say];
memcpy(input,arr,len);

for (say=0;say<len;say++)
	input[say]^=table[say%8];
for (say=0;say<len-1;say++)
	input[say]^=input[len-1];
return 1;
}

int DCWdecode(unsigned char *input, int len)
{
int		say;
unsigned char 	arr[100];
unsigned char 	table[8]={ 181,46,23,186,65,250,7,199 }; 

for (say=0;say<len-1;say++)
	input[say]^=input[len-1];

for (say=0;say<len;say++)
	input[say]^=table[say%8];
//reverse
memcpy(arr,input,len);
for (say=0;say<len;say++)
	arr[len-1-say]=input[say];
memcpy(input,arr,len);
return 1;
}
